import json
import sys
import requests


USERNAME = "admin"
PASSWORD = "admin"


def do_login(base_url):
    session = requests.session()

    login_data = json.dumps({
        "username": USERNAME,
        "password": PASSWORD
    }, ensure_ascii=True, indent=0)

    session.get(f"{base_url}/login")

    login_result = json.loads(session.post(f"{base_url}/login", headers={'Content-Type': 'application/json'}, data=login_data).content.decode('utf-8'))
    if "error" in login_result:
        raise RuntimeError(f"Failed to login: {login_result}")

    return session


def set_logging(base_url, value):
    session = do_login(base_url)
    res = session.post(f"{base_url}/dev/cpapicall?f=SetDmaDebug&param=log_bool&value={value}")
    print(res.content.decode('utf-8'))


if __name__ == '__main__':
    if len(sys.argv) < 3:
        print(f"Usage: {sys.argv[0]} http(s)://terminal-api logging on|off")
        exit(1)

    if sys.argv[2] == "logging":
        set_logging(sys.argv[1], {"on": "true", "off": "false"}[sys.argv[3]])
    else:
        print(f"Unknown action: {sys.argv[1]}")
